﻿using ProjectAirBomber.Entities;
using System.Diagnostics.CodeAnalysis;

namespace ProjectAirBomber.Drawnings;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawningAirCraftEqutables : IEqualityComparer<DrawningBomber?>
{
    public bool Equals(DrawningBomber? x, DrawningBomber? y)
    {
        if (x == null || x.EntityBomber == null)
        {
            return false;
        }

        if (y == null || y.EntityBomber == null)
        {
            return false;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }

        if (x.EntityBomber.Speed != y.EntityBomber.Speed)
        {
            return false;
        }

        if (x.EntityBomber.Weight != y.EntityBomber.Weight)
        {
            return false;
        }

        if (x.EntityBomber.BodyColor != y.EntityBomber.BodyColor)
        {
            return false;
        }

        if (x is DrawningAirBomber && y is DrawningAirBomber)
        {
            EntityAirBomber entityX = (EntityAirBomber)x.EntityBomber;
            EntityAirBomber entityY = (EntityAirBomber)y.EntityBomber;
            if (entityX.FuelTanks != entityY.FuelTanks)
            {
                return false;
            }
            if (entityX.Bombs != entityY.Bombs)
            {
                return false;
            }
            if (entityX.AdditionalColor != entityY.AdditionalColor)
            {
                return false;
            }
        }

        return true;
    }

    public int GetHashCode([DisallowNull] DrawningBomber obj)
    {
        return obj.GetHashCode();
    }
}